/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package base.gui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import base.ClassificationAction;


import util.featureSelection.FeatureSelectionStub.FEATURE_SELECTION_TYPE;


public class SprClassificationActionPanel extends JPanel implements ActionListener, KeyListener{
	
	public static final long serialVersionUID = 1125485465l;
	
	private JFileChooser fc = new JFileChooser("./");
	private Dimension minDimPanel = new Dimension(690,35);
	private Dimension minDimCheck = new Dimension(200,35);
	
	//name
	private JPanel namePanel 					= null;
	private JCheckBox nameCheck 				= null;
	private JTextField nameField 				= null;
	
	//classificationName 
	private JPanel classificationNamePanel 		= null;
	private JCheckBox classificationNameCheck 	= null;
	private JTextField classificationNameField 	= null;
	
	//classifier type
	private JPanel classifierTypePanel 			= null;
	private JCheckBox classifierTypeCheck 		= null;
	private JComboBox classifierTypeBox 		= null;
	
	//classifier options
	private JPanel classifierOptionsPanel 		= null;
	private JCheckBox classifierOptionsCheck 	= null;
	private JTextField classifierOptionsField 	= null;
	
	//command
	private JPanel commandPanel 				= null;
	private JCheckBox commandCheck 				= null;
	private JComboBox commandBox 				= null;
	
	//classificationFeature
	private JPanel classificationFeaturePanel	= null;
	private JCheckBox classificationFeatureCheck= null;
	private JButton classificationFeatureButton = null;
	private SprClassificationFeaturePanel cfp 		= null;
	
	//positive training file
	private JPanel positiveTrainingFilePanel	= null;
	private JCheckBox positiveTrainingFileCheck	= null;
	private JTextField positiveTrainingFileField = null;
	private JButton positiveTrainingFileButton	= null;
	
	//negative training file
	private JPanel negativeTrainingFilePanel	= null;
	private JCheckBox negativeTrainingFileCheck	= null;
	private JTextField negativeTrainingFileField = null;
	private JButton negativeTrainingFileButton	= null;
	
	//positive training file sec struct
	private JPanel positiveTrainingSSFilePanel		= null;
	private JCheckBox positiveTrainingSSFileCheck 	= null;
	private JTextField positiveTrainingSSFileField	= null;
	private JButton positiveTrainingSSFileButton	= null;
	
	//negative training file sec struct
	private JPanel negativeTrainingSSFilePanel		= null;
	private JCheckBox negativeTrainingSSFileCheck 	= null;
	private JTextField negativeTrainingSSFileField	= null;
	private JButton negativeTrainingSSFileButton	= null;
	
	//outputdirectory
	private JPanel outputDirPanel				= null;
	private JCheckBox outputDirCheck			= null;
	private JTextField outputDirField			= null;
	private JButton outputDirButton				= null;
	
	//splicesite position
	private JPanel functionalSitePanel			= null;
	private JCheckBox functionalSiteCheck		= null;
	private JTextField functionalSiteField		= null;
	
	//model file
	private JPanel modelFilePanel				= null;
	private JCheckBox modelFileCheck			= null;
	private JTextField modelFileField			= null;
	private JButton modelFileButton				= null;
	
	//features output file
	private JPanel featuresOutputPanel			= null;
	private JCheckBox featuresOutputCheck		= null;
	private JTextField featuresOutputField		= null;
	private JButton featuresOutputButton		= null;
	
	//test files
	private JPanel testFilesPanel				= null;
	private JCheckBox testFilesCheck			= null;
	private JTextField testFilesField			= null;
	private JButton testFilesButton				= null;
	
	//output prediction files
	private JPanel outputPredictionPanel		= null;
	private JCheckBox outputPredictionCheck		= null;
	private JTextField outputPredictionField	= null;
//	private JButton outputPredictionButton		= null;
	
	//filetype
	private JPanel fileTypePanel				= null;
	private JCheckBox fileTypeCheck				= null;
	private JComboBox fileTypeCombo				= null;
	
	//strand
	private JPanel strandPanel					= null;
	private JCheckBox strandCheck				= null;
	private JComboBox strandCombo				= null;
	
	//crossvalidation
	private JPanel crossvalidationPanel			= null;
	private JCheckBox crossvalidationCheck		= null;
	private JTextField crossvalidationField		= null;
	
	//crossvalidation complexity
	private JPanel crossvalidationComplexPanel		= null;
	private JCheckBox crossvalidationComplexCheck	= null;
	private JComboBox crossvalidationComplexCombo	= null;
	
	//maximum crossvalidation
	//private JPanel maxCrossvalPanel 			= null;
	//private JCheckBox maxCrossvalCheck			= null;
	//private JTextField maxCrossvalField			= null;
	
	//positive training amount
	private JPanel positiveAmountPanel			= null;
	private JCheckBox positiveAmountCheck		= null;
	private JTextField positiveAmountField		= null;
	
	//negative training amount
	private JPanel negativeAmountPanel			= null;
	private JCheckBox negativeAmountCheck		= null;
	private JTextField negativeAmountField		= null;
	
	//classification pattern
	private JPanel classificationPatternPanel	= null;
	private JCheckBox classificationPatternCheck= null;
	private JTextField classificationPatternField = null;
	
	//classification pattern location
	private JPanel classificationPatternLocPanel	= null;
	private JCheckBox classificationPatternLocCheck	= null;
	private JTextField classificationPatternLocField= null;
	
	//classification pattern output
	private JPanel classificationPatternOutPanel	= null;
	private JCheckBox classificationPatternOutCheck	= null;
	private JTextField classificationPatternOutField1 = null;
	private JTextField classificationPatternOutField2 = null;
	
	
	//feature selection type
	private JPanel featureSelectionTypePanel		= null;
	private JCheckBox featureSelectionTypeCheck		= null;
	private JComboBox featureSelectionTypeCombo		= null;
	
	//feature selection purpose
	private JPanel featureSelectionPurposePanel		= null;
	private JCheckBox featureSelectionPurposeCheck	= null;
	private JComboBox featureSelectionPurposeCombo	= null;
	
	//feature selection input file
	private JPanel featureSelectionInputFilePanel		= null;
	private JCheckBox featureSelectionInputFileCheck	= null;
	private JTextField featureSelectionInputFileField 	= null;
	private JButton featureSelectionInputFileButton		= null;
	
	//feature selection output file
	private JPanel featureSelectionOutputFilePanel		= null;
	private JCheckBox featureSelectionOutputFileCheck	= null;
	private JTextField featureSelectionOutputFileField	= null;
	
	//max features
	private JPanel featureSelectionMaxFeatPanel			= null;
	private JCheckBox featureSelectionMaxFeatCheck		= null;
	private JTextField featureSelectionMaxFeatField		= null;
	
	
	
	private ClassificationAction classifAction = null;
	
	
	private void setDimensionsObject(JComponent c,Dimension d){
		c.setMaximumSize(d);
		c.setMinimumSize(d);
		c.setPreferredSize(d);
	}
	
	private void createContent(ClassificationAction ca){
		this.setLayout(new BorderLayout());
		JPanel mainContent = new JPanel(new GridLayout(30,1));
		FlowLayout lay = new FlowLayout();
		lay.setAlignment(FlowLayout.LEFT);
		
		/*
		 *****************************************************
		 * FIRST PART : CREATION
		 *****************************************************
		 */
		
		//namepanel
		namePanel = new JPanel(lay);
		setDimensionsObject(namePanel,minDimPanel);
		nameCheck = new JCheckBox("Name :");
		setDimensionsObject(nameCheck,minDimCheck);
		nameCheck.setSelected(true);
		nameCheck.addActionListener(this);
		nameField = new JTextField(20);
		namePanel.add(nameCheck);
		namePanel.add(nameField);
		mainContent.add(namePanel);
		
		//classificationname
		classificationNamePanel = new JPanel(lay);
		setDimensionsObject(classificationNamePanel,minDimPanel);
		classificationNameCheck = new JCheckBox("Classification Name :");
		setDimensionsObject(classificationNameCheck,minDimCheck);
		classificationNameCheck.setSelected(true);
		classificationNameCheck.addActionListener(this);
		classificationNameField = new JTextField(20);
		classificationNamePanel.add(classificationNameCheck);
		classificationNamePanel.add(classificationNameField);
		mainContent.add(classificationNamePanel);
		
		//classifier type
		classifierTypePanel = new JPanel(lay);
		setDimensionsObject(classifierTypePanel,minDimPanel);
		classifierTypeCheck = new JCheckBox("Classifier type :");
		setDimensionsObject(classifierTypeCheck,minDimCheck);
		classifierTypeCheck.setSelected(true);
		classifierTypeCheck.addActionListener(this);
		String[] classifierTypePossibleValues = {"WEKASVM"};
		classifierTypeBox = new JComboBox(classifierTypePossibleValues);
		classifierTypePanel.add(classifierTypeCheck);
		classifierTypePanel.add(classifierTypeBox);
		mainContent.add(classifierTypePanel);
		
		//classifier options
		classifierOptionsPanel = new JPanel(lay);
		setDimensionsObject(classifierOptionsPanel,minDimPanel);
		classifierOptionsCheck = new JCheckBox("Classifier options :");
		setDimensionsObject(classifierOptionsCheck,minDimCheck);
		classifierOptionsCheck.setSelected(true);
		classifierOptionsCheck.addActionListener(this);
		classifierOptionsField = new JTextField(20);
		classifierOptionsPanel.add(classifierOptionsCheck);
		classifierOptionsPanel.add(classifierOptionsField);
		mainContent.add(classifierOptionsPanel);
		
		//command
		commandPanel = new JPanel(lay);
		setDimensionsObject(commandPanel,minDimPanel);
		commandCheck = new JCheckBox("Command :");
		setDimensionsObject(commandCheck,minDimCheck);
		commandCheck.setSelected(true);
		commandCheck.addActionListener(this);
		String[] commandPossibleValues = {"BUILD_MODEL","LOAD_MODEL"};
		commandBox = new JComboBox(commandPossibleValues);
		commandPanel.add(commandCheck);
		commandPanel.add(commandBox);
		mainContent.add(commandPanel);
		
		//classificationFeature
		classificationFeaturePanel = new JPanel(lay);
		setDimensionsObject(classificationFeaturePanel,minDimPanel);
		classificationFeatureCheck = new JCheckBox("ClassificationFeatures :");
		setDimensionsObject(classificationFeatureCheck,minDimCheck);
		classificationFeatureCheck.setSelected(true);
		classificationFeatureCheck.addActionListener(this);
		classificationFeatureButton = new JButton("Edit classificationFeatures");
		classificationFeatureButton.addActionListener(this);
		classificationFeaturePanel.add(classificationFeatureCheck);
		classificationFeaturePanel.add(classificationFeatureButton);
		mainContent.add(classificationFeaturePanel);
		cfp = new SprClassificationFeaturePanel(ca, new Dimension(500,200));
		
		//positiveTrainingFile
		positiveTrainingFilePanel = new JPanel(lay);
		setDimensionsObject(positiveTrainingFilePanel,minDimPanel);
		positiveTrainingFileCheck = new JCheckBox("Positive training file :");
		setDimensionsObject(positiveTrainingFileCheck,minDimCheck);
		positiveTrainingFileCheck.setSelected(true);
		positiveTrainingFileCheck.addActionListener(this);
		positiveTrainingFileField = new JTextField(30);
		positiveTrainingFileButton = new JButton("Search file");
		positiveTrainingFileButton.addActionListener(this);
		positiveTrainingFilePanel.add(positiveTrainingFileCheck);
		positiveTrainingFilePanel.add(positiveTrainingFileField);
		positiveTrainingFilePanel.add(positiveTrainingFileButton);
		mainContent.add(positiveTrainingFilePanel);
		
		//negativeTrainingFile
		negativeTrainingFilePanel = new JPanel(lay);
		setDimensionsObject(negativeTrainingFilePanel,minDimPanel);
		negativeTrainingFileCheck = new JCheckBox("Negative training file :");
		setDimensionsObject(negativeTrainingFileCheck,minDimCheck);
		negativeTrainingFileCheck.setSelected(true);
		negativeTrainingFileCheck.addActionListener(this);
		negativeTrainingFileField = new JTextField(30);
		negativeTrainingFileButton = new JButton("Search file");
		negativeTrainingFileButton.addActionListener(this);
		negativeTrainingFilePanel.add(negativeTrainingFileCheck);
		negativeTrainingFilePanel.add(negativeTrainingFileField);
		negativeTrainingFilePanel.add(negativeTrainingFileButton);
		mainContent.add(negativeTrainingFilePanel);
		
		//positiveTrainingFileSecStruct
		positiveTrainingSSFilePanel = new JPanel(lay);
		setDimensionsObject(positiveTrainingSSFilePanel,minDimPanel);
		positiveTrainingSSFileCheck = new JCheckBox("Positive training file SecStruct :");
		setDimensionsObject(positiveTrainingSSFileCheck,minDimCheck);
		positiveTrainingSSFileCheck.setSelected(true);
		positiveTrainingSSFileCheck.addActionListener(this);
		positiveTrainingSSFileField = new JTextField(30);
		positiveTrainingSSFileButton = new JButton("Search file");
		positiveTrainingSSFileButton.addActionListener(this);
		positiveTrainingSSFilePanel.add(positiveTrainingSSFileCheck);
		positiveTrainingSSFilePanel.add(positiveTrainingSSFileField);
		positiveTrainingSSFilePanel.add(positiveTrainingSSFileButton);
		mainContent.add(positiveTrainingSSFilePanel);
		
		//negativeTrainingFileSecStruct
		negativeTrainingSSFilePanel = new JPanel(lay);
		setDimensionsObject(negativeTrainingSSFilePanel,minDimPanel);
		negativeTrainingSSFileCheck = new JCheckBox("Negative training file SecStruct :");
		setDimensionsObject(negativeTrainingSSFileCheck,minDimCheck);
		negativeTrainingSSFileCheck.setSelected(true);
		negativeTrainingSSFileCheck.addActionListener(this);
		negativeTrainingSSFileField = new JTextField(30);
		negativeTrainingSSFileButton = new JButton("Search file");
		negativeTrainingSSFileButton.addActionListener(this);
		negativeTrainingSSFilePanel.add(negativeTrainingSSFileCheck);
		negativeTrainingSSFilePanel.add(negativeTrainingSSFileField);
		negativeTrainingSSFilePanel.add(negativeTrainingSSFileButton);
		mainContent.add(negativeTrainingSSFilePanel);
		
		//outputdir
		outputDirPanel = new JPanel(lay);
		setDimensionsObject(outputDirPanel,minDimPanel);
		outputDirCheck = new JCheckBox("Output directory :");
		setDimensionsObject(outputDirCheck,minDimCheck);
		outputDirCheck.setSelected(true);
		outputDirCheck.addActionListener(this);
		outputDirField = new JTextField(30);
		outputDirButton	= new JButton("Search directory");
		outputDirButton.addActionListener(this);
		outputDirPanel.add(outputDirCheck);
		outputDirPanel.add(outputDirField);
		outputDirPanel.add(outputDirButton);
		mainContent.add(outputDirPanel);
		
		//splice site
		functionalSitePanel = new JPanel(lay);
		setDimensionsObject(functionalSitePanel,minDimPanel);
		functionalSiteCheck = new JCheckBox("Functional site position (training):");
		setDimensionsObject(functionalSiteCheck,minDimCheck);
		functionalSiteCheck.setSelected(true);
		functionalSiteCheck.addActionListener(this);
		functionalSiteField = new JTextField(10);
		functionalSiteField.addKeyListener(this);
		functionalSitePanel.add(functionalSiteCheck);
		functionalSitePanel.add(functionalSiteField);
		mainContent.add(functionalSitePanel);
		
		//model file
		modelFilePanel	= new JPanel(lay);
		setDimensionsObject(modelFilePanel,minDimPanel);
		modelFileCheck = new JCheckBox("Model file :");
		setDimensionsObject(modelFileCheck,minDimCheck);
		modelFileCheck.setSelected(true);
		modelFileCheck.addActionListener(this);
		modelFileField = new JTextField(30);
		modelFileButton = new JButton("Search file");
		modelFileButton.addActionListener(this);
		modelFilePanel.add(modelFileCheck);
		modelFilePanel.add(modelFileField);
		modelFilePanel.add(modelFileButton);
		mainContent.add(modelFilePanel);
		
		//features output file
		featuresOutputPanel = new JPanel(lay);
		setDimensionsObject(featuresOutputPanel,minDimPanel);
		featuresOutputCheck = new JCheckBox("Features outputfile:");
		setDimensionsObject(featuresOutputCheck,minDimCheck);
		featuresOutputCheck.setSelected(true);
		featuresOutputCheck.addActionListener(this);
		featuresOutputField = new JTextField(30);
		featuresOutputButton = new JButton("Search file");
		featuresOutputButton.addActionListener(this);
		featuresOutputPanel.add(featuresOutputCheck);
		featuresOutputPanel.add(featuresOutputField);
		featuresOutputPanel.add(featuresOutputButton);
		mainContent.add(featuresOutputPanel);
		
		//test files
		testFilesPanel = new JPanel(lay);
		setDimensionsObject(testFilesPanel,minDimPanel);
		testFilesCheck = new JCheckBox("Test files:");
		setDimensionsObject(testFilesCheck,minDimCheck);
		testFilesCheck.setSelected(true);
		testFilesCheck.addActionListener(this);
		testFilesField = new JTextField(30);
		testFilesButton = new JButton("Search file");
		testFilesButton.addActionListener(this);
		testFilesPanel.add(testFilesCheck);
		testFilesPanel.add(testFilesField);
		testFilesPanel.add(testFilesButton);
		mainContent.add(testFilesPanel);
	
		//output prediction files
		outputPredictionPanel = new JPanel(lay);
		setDimensionsObject(outputPredictionPanel,minDimPanel);
		outputPredictionCheck = new JCheckBox("Output prediction files:");
		setDimensionsObject(outputPredictionCheck,minDimCheck);
		outputPredictionCheck.setSelected(true);
		outputPredictionCheck.addActionListener(this);
		outputPredictionField = new JTextField(30);
		outputPredictionPanel.add(outputPredictionCheck);
		outputPredictionPanel.add(outputPredictionField);
		mainContent.add(outputPredictionPanel);

		
		//filetype
		fileTypePanel = new JPanel(lay);
		setDimensionsObject(fileTypePanel,minDimPanel);
		fileTypeCheck = new JCheckBox("File type:");
		setDimensionsObject(fileTypeCheck,minDimCheck);
		fileTypeCheck.setSelected(true);
		fileTypeCheck.addActionListener(this);
		String [] possibleFileTypes = {"FASTA","EMBL"};
		fileTypeCombo = new JComboBox(possibleFileTypes);
		fileTypePanel.add(fileTypeCheck);
		fileTypePanel.add(fileTypeCombo);
		mainContent.add(fileTypePanel);

		
		//strand
		strandPanel = new JPanel(lay);
		setDimensionsObject(strandPanel,minDimPanel);
		strandCheck = new JCheckBox("Strand :");
		setDimensionsObject(strandCheck,minDimCheck);
		strandCheck.setSelected(true);
		strandCheck.addActionListener(this);
		String [] possibleStrands = {"FORWARD","REVERSE","BOTH"};
		strandCombo = new JComboBox(possibleStrands);
		strandPanel.add(strandCheck);
		strandPanel.add(strandCombo);
		mainContent.add(strandPanel);
		
		
		//crossvalidation
		crossvalidationPanel = new JPanel(lay);
		setDimensionsObject(crossvalidationPanel,minDimPanel);
		crossvalidationCheck = new JCheckBox("Crossvalidation :");
		setDimensionsObject(crossvalidationCheck,minDimCheck);
		crossvalidationCheck.setSelected(true);
		crossvalidationCheck.addActionListener(this);
		crossvalidationField = new JTextField(10);
		crossvalidationField.addKeyListener(this);
		crossvalidationPanel.add(crossvalidationCheck);
		crossvalidationPanel.add(crossvalidationField);
		mainContent.add(crossvalidationPanel);

		
		//crossvalidation complexity
		crossvalidationComplexPanel = new JPanel(lay);
		setDimensionsObject(crossvalidationComplexPanel,minDimPanel);
		crossvalidationComplexCheck = new JCheckBox("Crossvalidation c:");
		setDimensionsObject(crossvalidationComplexCheck,minDimCheck);
		crossvalidationComplexCheck.setSelected(true);
		crossvalidationComplexCheck.addActionListener(this);
		String[] possibleCrossvalComplex = {"FALSE","TRUE"};
		crossvalidationComplexCombo = new JComboBox(possibleCrossvalComplex);
		crossvalidationComplexPanel.add(crossvalidationComplexCheck);
		crossvalidationComplexPanel.add(crossvalidationComplexCombo);
		mainContent.add(crossvalidationComplexPanel);

		//maximum crossvalidation
		/*maxCrossvalPanel = new JPanel(lay);
		setDimensionsObject(maxCrossvalPanel,minDimPanel);
		maxCrossvalCheck = new JCheckBox("max crosval (test):");
		setDimensionsObject(maxCrossvalCheck,minDimCheck);
		maxCrossvalCheck.setSelected(false);
		maxCrossvalCheck.addActionListener(this);
		maxCrossvalField = new JTextField(10);
		maxCrossvalField.addKeyListener(this);
		maxCrossvalPanel.add(maxCrossvalCheck);
		maxCrossvalPanel.add(maxCrossvalField);
		mainContent.add(maxCrossvalPanel);
		setAccordingToCheck(maxCrossvalCheck.isSelected(),maxCrossvalCheck,maxCrossvalPanel);*/
		
		
		//positive training amount
		positiveAmountPanel = new JPanel(lay);
		setDimensionsObject(positiveAmountPanel,minDimPanel);
		positiveAmountCheck = new JCheckBox("positive training # :");
		setDimensionsObject(positiveAmountCheck,minDimCheck);
		positiveAmountCheck.setSelected(true);
		positiveAmountCheck.addActionListener(this);
		positiveAmountField = new JTextField(10);
		positiveAmountField.addKeyListener(this);
		positiveAmountPanel.add(positiveAmountCheck);
		positiveAmountPanel.add(positiveAmountField);
		mainContent.add(positiveAmountPanel);
		
		
		//negative training amount
		negativeAmountPanel = new JPanel(lay);
		setDimensionsObject(negativeAmountPanel,minDimPanel);
		negativeAmountCheck = new JCheckBox("negative training # :");
		setDimensionsObject(negativeAmountCheck,minDimCheck);
		negativeAmountCheck.setSelected(true);
		negativeAmountCheck.addActionListener(this);
		negativeAmountField = new JTextField(10);
		negativeAmountField.addKeyListener(this);
		negativeAmountPanel.add(negativeAmountCheck);
		negativeAmountPanel.add(negativeAmountField);
		mainContent.add(negativeAmountPanel);
		
		
		//classification pattern
		classificationPatternPanel = new JPanel(lay);
		setDimensionsObject(classificationPatternPanel,minDimPanel);
		classificationPatternCheck = new JCheckBox("Classification pattern :");
		setDimensionsObject(classificationPatternCheck,minDimCheck);
		classificationPatternCheck.setSelected(true);
		classificationPatternCheck.addActionListener(this);
		classificationPatternField = new JTextField(10);
		classificationPatternPanel.add(classificationPatternCheck);
		classificationPatternPanel.add(classificationPatternField);
		mainContent.add(classificationPatternPanel);

		
		//classification pattern location
		classificationPatternLocPanel = new JPanel(lay);
		setDimensionsObject(classificationPatternLocPanel,minDimPanel);
		classificationPatternLocCheck = new JCheckBox("Classification pattern location:");
		setDimensionsObject(classificationPatternLocCheck,minDimCheck);
		classificationPatternLocCheck.setSelected(true);
		classificationPatternLocCheck.addActionListener(this);
		classificationPatternLocField = new JTextField(10);
		classificationPatternLocField.addKeyListener(this);
		classificationPatternLocPanel.add(classificationPatternLocCheck);
		classificationPatternLocPanel.add(classificationPatternLocField);
		mainContent.add(classificationPatternLocPanel);
		
		//classification pattern output
		classificationPatternOutPanel = new JPanel(lay);
		setDimensionsObject(classificationPatternOutPanel,minDimPanel);
		classificationPatternOutCheck = new JCheckBox("Pattern output location:");
		setDimensionsObject(classificationPatternOutCheck,minDimCheck);
		classificationPatternOutCheck.setSelected(true);
		classificationPatternOutCheck.addActionListener(this);
		classificationPatternOutField1 = new JTextField(10);
		classificationPatternOutField2 = new JTextField(10);
		classificationPatternOutField1.addKeyListener(this);
		classificationPatternOutField2.addKeyListener(this);
		classificationPatternOutPanel.add(classificationPatternOutCheck);
		classificationPatternOutPanel.add(classificationPatternOutField1);
		classificationPatternOutPanel.add(classificationPatternOutField2);
		mainContent.add(classificationPatternOutPanel);

		//feature selection type
		featureSelectionTypePanel = new JPanel(lay);
		setDimensionsObject(featureSelectionTypePanel,minDimPanel);
		featureSelectionTypeCheck = new JCheckBox("Feature selection type:");
		setDimensionsObject(featureSelectionTypeCheck,minDimCheck);
		featureSelectionTypeCheck.setSelected(true);
		featureSelectionTypeCheck.addActionListener(this);
		String[] possibleFeatSelTypes = {"NO_FEATURE_SELECTION","PRECOMPUTED_FILTER",
				"SYMMETRICAL_UNCERTAINTY","CFS","INFORMATION_GAIN","CHI_SQUARED","GAIN_RATIO",
				"RELIEF","FCBF"};
		featureSelectionTypeCombo = new JComboBox(possibleFeatSelTypes);
		featureSelectionTypePanel.add(featureSelectionTypeCheck);
		featureSelectionTypePanel.add(featureSelectionTypeCombo);
		mainContent.add(featureSelectionTypePanel);
		
		
		//feature selection purpose
		featureSelectionPurposePanel = new JPanel(lay);
		setDimensionsObject(featureSelectionPurposePanel,minDimPanel);
		featureSelectionPurposeCheck = new JCheckBox("Feature selection purpose:");
		setDimensionsObject(featureSelectionPurposeCheck,minDimCheck);
		featureSelectionPurposeCheck.setSelected(true);
		featureSelectionPurposeCheck.addActionListener(this);
		String[] possibleFeatSelPurps = {"USE_FILTER","WRITER_MINIMAL_FILTER",
				"WRITER_FULL_FILTER","LOAD_FILTER","USE_AND_WRITE_FULL_FILTER"};
		featureSelectionPurposeCombo = new JComboBox(possibleFeatSelPurps);
		featureSelectionPurposePanel.add(featureSelectionPurposeCheck);
		featureSelectionPurposePanel.add(featureSelectionPurposeCombo);
		mainContent.add(featureSelectionPurposePanel);
		
		
		//feature selection input file
		featureSelectionInputFilePanel = new JPanel(lay);
		setDimensionsObject(featureSelectionInputFilePanel,minDimPanel);
		featureSelectionInputFileCheck = new JCheckBox("Feature selection inputfile:");
		setDimensionsObject(featureSelectionInputFileCheck,minDimCheck);
		featureSelectionInputFileCheck.setSelected(true);
		featureSelectionInputFileCheck.addActionListener(this);
		featureSelectionInputFileField = new JTextField(30);
		featureSelectionInputFileButton = new JButton("Search file");
		featureSelectionInputFileButton.addActionListener(this);
		featureSelectionInputFilePanel.add(featureSelectionInputFileCheck);
		featureSelectionInputFilePanel.add(featureSelectionInputFileField);
		featureSelectionInputFilePanel.add(featureSelectionInputFileButton);
		mainContent.add(featureSelectionInputFilePanel);
		
		
		//feature selection output file
		featureSelectionOutputFilePanel = new JPanel(lay);
		setDimensionsObject(featureSelectionOutputFilePanel,minDimPanel);
		featureSelectionOutputFileCheck = new JCheckBox("Feature selection outputfile:");
		setDimensionsObject(featureSelectionOutputFileCheck,minDimCheck);
		featureSelectionOutputFileCheck.setSelected(true);
		featureSelectionOutputFileCheck.addActionListener(this);
		featureSelectionOutputFileField = new JTextField(30);
		featureSelectionOutputFilePanel.add(featureSelectionOutputFileCheck);
		featureSelectionOutputFilePanel.add(featureSelectionOutputFileField);
		mainContent.add(featureSelectionOutputFilePanel);
		
		//max features
		featureSelectionMaxFeatPanel = new JPanel(lay);
		setDimensionsObject(featureSelectionMaxFeatPanel,minDimPanel);
		featureSelectionMaxFeatCheck = new JCheckBox("Max features :");
		setDimensionsObject(featureSelectionMaxFeatCheck,minDimCheck);
		featureSelectionMaxFeatCheck.setSelected(true);
		featureSelectionMaxFeatCheck.addActionListener(this);
		featureSelectionMaxFeatField = new JTextField(10);
		featureSelectionMaxFeatField.addKeyListener(this);
		featureSelectionMaxFeatPanel.add(featureSelectionMaxFeatCheck);
		featureSelectionMaxFeatPanel.add(featureSelectionMaxFeatField);
		mainContent.add(featureSelectionMaxFeatPanel);
		
		
		JScrollPane scroll = new JScrollPane(mainContent);
		this.add(scroll);
		
		/*
		 *****************************************************
		 * SECOND PART : Filling in the fields
		 ***************************************************** 
		 */
		if(ca==null){	//cannot get any information
			return;
		}
		//name
		if(ca.getName()!=null)
			this.nameField.setText(ca.getName());
		//classificationName
		if(ca.getClassification_name()!=null)
			this.classificationNameField.setText(ca.getClassification_name());
		//classifier type
		this.classifierTypeBox.setSelectedItem(ca.getClassifier_type().toString());
		//classifier options
		if(ca.getClassifier_options()!=null){
			String res = "";
			String [] t = ca.getClassifier_options();
			for(int i=0;i<t.length;i++)
				res+=t[i]+" ";
			this.classifierOptionsField.setText(res);
		}
		else
			exclude(classifierOptionsCheck,classifierOptionsPanel);
		
		//command
		this.commandBox.setSelectedItem(ca.getCommand().toString());
		//classifier-features : done automatically
		//positive training file
		if(ca.getPositive_training_file()!=null)
			this.positiveTrainingFileField.setText(ca.getPositive_training_file());
		else
			exclude(positiveTrainingFileCheck,positiveTrainingFilePanel);
		//negative training file
		if(ca.getNegative_training_file()!=null)
			this.negativeTrainingFileField.setText(ca.getNegative_training_file());
		else
			exclude(negativeTrainingFileCheck,negativeTrainingFilePanel);
		//positive ss training file
		if(ca.getPositive_training_file_secstruct()!=null)
			this.positiveTrainingSSFileField.setText(ca.getPositive_training_file_secstruct());
		else
			exclude(positiveTrainingSSFileCheck,positiveTrainingSSFilePanel);
		//negative ss training file
		if(ca.getNegative_training_file_secstruct()!=null)
			this.negativeTrainingSSFileField.setText(ca.getNegative_training_file_secstruct());
		else
			exclude(negativeTrainingSSFileCheck,negativeTrainingSSFilePanel);
		//outputdir
		if(ca.getOutputdirectory()!=null)
			this.outputDirField.setText(ca.getOutputdirectory());
		//splice site
		if(ca.getTraining_functional_site_position()!=-1)
			this.functionalSiteField.setText(""+ca.getTraining_functional_site_position());
		//model file
		if(ca.getModel_file()!=null)
			this.modelFileField.setText(ca.getModel_file());
		//features output
		if(ca.getFeatures_output_file()!=null)
			this.featuresOutputField.setText(ca.getFeatures_output_file());
		//test files
		if(ca.getTestfiles()!=null){
			String res = "";
			String[] temp = ca.getTestfiles();
			for(int i=0;i<temp.length;i++)
				res+=temp[i]+" ";
			this.testFilesField.setText(res);
		}
		else
			exclude(testFilesCheck,testFilesPanel);
		//output prediction
		if(ca.getPredictionOutputFiles()!=null){
			String res = "";
			String[] temp = ca.getPredictionOutputFiles();
			for(int i=0;i<temp.length;i++)
				res+=temp[i]+" ";
			this.outputPredictionField.setText(res);
		}
		else
			exclude(outputPredictionCheck,outputPredictionPanel);
		//filetype
		fileTypeCombo.setSelectedItem(ca.getTestfiles_filetype().toString());
		//strand
		strandCombo.setSelectedItem(ca.getStrand().toString());
		//crossvalidation
		if(ca.getCrossvalidation_fold()!=-1)
			this.crossvalidationField.setText(""+ca.getCrossvalidation_fold());
		else{
			exclude(crossvalidationCheck,crossvalidationPanel);
		}
		//crossvalidation complex
		if(ca.isComplexityCrossvalidation()){
			this.crossvalidationComplexCombo.setSelectedItem("TRUE");
		}
		else{
			exclude(crossvalidationComplexCheck,crossvalidationComplexPanel);
		}
		//positive training amount
		if(ca.getPositive_training_amount()!=-1)
			this.positiveAmountField.setText(""+ca.getPositive_training_amount());
		else{
			exclude(positiveAmountCheck,positiveAmountPanel);
		}
		//negative training amount
		if(ca.getNegative_training_amount()!=-1)
			this.negativeAmountField.setText(""+ca.getNegative_training_amount());
		else{
			exclude(negativeAmountCheck,negativeAmountPanel);
		}
		//classification pattern
		if(ca.getPattern()!=null)
			this.classificationPatternField.setText(ca.getPattern());
		//pattern location
		if(ca.getPattern_classification_location()==0){
			exclude(classificationPatternLocCheck,classificationPatternLocPanel);
		}
		else{
			this.classificationPatternLocField.setText(""+ca.getPattern_classification_location());
		}
		//pattern output
		int cpo1 = ca.getPattern_classification_output_f();
		int cpo2 = ca.getPattern_classification_output_r();
		if(cpo1==0&&cpo2==0){
			exclude(classificationPatternOutCheck,classificationPatternOutPanel);
		}
		else{
			this.classificationPatternOutField1.setText(""+cpo1);
			this.classificationPatternOutField2.setText(""+cpo2);
		}
		//feature selection type
		if(ca.getFeatureSelection().getFeature_selection_type()==FEATURE_SELECTION_TYPE.NO_FEATURE_SELECTION){
			exclude(featureSelectionTypeCheck,featureSelectionTypePanel);
			exclude(featureSelectionPurposeCheck,featureSelectionPurposePanel);
			exclude(featureSelectionInputFileCheck,featureSelectionInputFilePanel);
			exclude(featureSelectionOutputFileCheck,featureSelectionOutputFilePanel);
			exclude(featureSelectionMaxFeatCheck,featureSelectionMaxFeatPanel);
		}
		else{
			this.featureSelectionTypeCombo.setSelectedItem(ca.getFeatureSelection().getFeature_selection_type().toString());
			//feature selection purpose
			this.featureSelectionPurposeCombo.setSelectedItem(ca.getFeatureSelection().getFeature_selection_purpose().toString());
			if(ca.getFeatureSelection().getFeature_selection_input_file()!=null)
				this.featureSelectionInputFileField.setText(ca.getFeatureSelection().getFeature_selection_input_file());
			else
				exclude(featureSelectionInputFileCheck,featureSelectionInputFilePanel);
			if(ca.getFeatureSelection().getFeature_selection_output_file()!=null)
				this.featureSelectionOutputFileField.setText(ca.getFeatureSelection().getFeature_selection_output_file());
			else
				exclude(featureSelectionOutputFileCheck,featureSelectionOutputFilePanel);
			if(ca.getFeatureSelection().getMaxNumFeatures()!=-1)
				this.featureSelectionMaxFeatField.setText(""+ca.getFeatureSelection().getMaxNumFeatures());
			else
				exclude(featureSelectionMaxFeatCheck,featureSelectionMaxFeatPanel);
		}
	}

	public void exclude(JCheckBox check,JPanel panel){
		check.setSelected(false);
		setAccordingToCheck(check.isSelected(),check,panel);
	}
	
	
	public String getCaString(){
		StringBuffer res = new StringBuffer();
		res.append("ACTION\n");
		res.append("END\n");
		return res.toString();
	}
	
	public SprClassificationActionPanel(ClassificationAction ca){
		super();	
		Dimension d = new Dimension(700,600);
		this.setPreferredSize(d);
		this.setMaximumSize(d);
		this.setPreferredSize(d);
		this.classifAction = ca;
		createContent(ca);
	}
	
	public boolean isInteger(String t){
		if(t==null||t.equals(""))
			return false;
		try{
			Integer.parseInt(t);
			return true;
		}
		catch(Exception exc){
			return false;
		}
	}
	
	public void fillClassificationAction(){
		//name
		if(nameCheck.isSelected()&& !nameField.getText().equals(""))
			classifAction.setName(nameField.getText());
		//classification-name
		if(classificationNameCheck.isSelected()&& !classificationNameField.getText().equals(""))
			classifAction.setClassification_name(classificationNameField.getText());
		//classifier type
		if(classifierTypeCheck.isSelected())
			classifAction.setClassifier_type(classifierTypeBox.getSelectedItem().toString());
		//classifier options
		if(classifierOptionsCheck.isSelected()&& !classifierOptionsField.getText().equals(""))
			classifAction.setClassifier_options(classifierOptionsField.getText().split(" "));
		//command
		if(commandCheck.isSelected())
			classifAction.setCommand(commandBox.getSelectedItem().toString());
		//classification features : filled in automatically
		//positive training file
		if(positiveTrainingFileCheck.isSelected()&& !positiveTrainingFileField.getText().equals(""))
			classifAction.setPositive_training_file(positiveTrainingFileField.getText());
		//negative training file
		if(negativeTrainingFileCheck.isSelected()&&!negativeTrainingFileField.getText().equals(""))
			classifAction.setNegative_training_file(negativeTrainingFileField.getText());
		//positive training ss file
		if(positiveTrainingSSFileCheck.isSelected()&&!positiveTrainingSSFileField.getText().equals(""))
			classifAction.setPositive_training_file_secstruct(positiveTrainingSSFileField.getText());
		//negative training ss file
		if(negativeTrainingSSFileCheck.isSelected()&&!negativeTrainingSSFileField.getText().equals(""))
			classifAction.setNegative_training_file_secstruct(negativeTrainingSSFileField.getText());
		//output dir
		if(outputDirCheck.isSelected()&&!outputDirField.getText().equals("")){
			String dir = outputDirField.getText();
			if(!dir.endsWith("/"))
				dir+="/";
			classifAction.setOutputdirectory(dir);
		}
			
		//splice site
		if(functionalSiteCheck.isSelected()&&isInteger(functionalSiteField.getText()))
			classifAction.setTraining_functional_site_position(Integer.parseInt(functionalSiteField.getText()));
		//model file
		if(modelFileCheck.isSelected()&&!modelFileField.getText().equals(""))
			classifAction.setModel_file(modelFileField.getText());
		//features output
		if(featuresOutputCheck.isSelected()&&!featuresOutputField.getText().equals(""))
			classifAction.setFeatures_output_file(featuresOutputField.getText());
		//testfiles
		if(testFilesCheck.isSelected()&&!testFilesField.getText().equals(""))
			classifAction.setTestfiles(testFilesField.getText().split(" "));
		//output prediction
		if(outputPredictionCheck.isSelected()&&!outputPredictionField.getText().equals(""))
			classifAction.setPredictionOutputFiles(outputPredictionField.getText().split(" "));
		//filetype
		if(fileTypeCheck.isSelected())
			classifAction.setTestfiles_filetype(fileTypeCombo.getSelectedItem().toString());
		//strand
		if(strandCheck.isSelected())
			classifAction.setStrand(strandCombo.getSelectedItem().toString());
		//crossvalidation
		if(crossvalidationCheck.isSelected()&&isInteger(crossvalidationField.getText()))
			classifAction.setCrossvalidation_fold(Integer.parseInt(crossvalidationField.getText()));
		//crossvalidation complex
		if(crossvalidationComplexCheck.isSelected())
			classifAction.setComplexityCrossvalidation(crossvalidationComplexCombo.getSelectedItem().toString().equals("TRUE")?true:false);
		//positive amoutn
		if(positiveAmountCheck.isSelected()&&isInteger(positiveAmountField.getText()))
			classifAction.setPositive_training_amount(Integer.parseInt(positiveAmountField.getText()));
		//negative amount
		if(negativeAmountCheck.isSelected()&&isInteger(negativeAmountField.getText()))
			classifAction.setNegative_training_amount(Integer.parseInt(negativeAmountField.getText()));
		//classif pattern
		if(classificationPatternCheck.isSelected()&&!classificationPatternField.getText().equals(""))
			classifAction.setPattern(classificationPatternField.getText());
		//classif pattern location
		if(classificationPatternLocCheck.isSelected()&&isInteger(classificationPatternLocField.getText()))
			classifAction.setPattern_classification_location(Integer.parseInt(classificationPatternLocField.getText()));
		//classif pattern output
		if(classificationPatternOutCheck.isSelected()&&isInteger(classificationPatternOutField1.getText())&&isInteger(classificationPatternOutField2.getText())){
			classifAction.setPattern_classification_output_f(Integer.parseInt(classificationPatternOutField1.getText()));
			classifAction.setPattern_classification_output_r(Integer.parseInt(classificationPatternOutField2.getText()));
		}
		//feature selection type
		if(featureSelectionTypeCheck.isSelected())
			classifAction.getFeatureSelection().setFeature_selection_type(featureSelectionTypeCombo.getSelectedItem().toString());
		//feature selection purpose
		if(featureSelectionPurposeCheck.isSelected())
			classifAction.getFeatureSelection().setFeature_selection_purpose(featureSelectionPurposeCombo.getSelectedItem().toString());
		//feature selection input
		if(featureSelectionInputFileCheck.isSelected()&&!featureSelectionInputFileField.getText().equals(""))
			classifAction.getFeatureSelection().setFeature_selection_input_file(featureSelectionInputFileField.getText());
		//feature selection output
		if(featureSelectionOutputFileCheck.isSelected()&&!featureSelectionOutputFileField.getText().equals(""))
			classifAction.getFeatureSelection().setFeature_selection_output_file(featureSelectionOutputFileField.getText());
		//feature selection max feat
		if(featureSelectionMaxFeatCheck.isSelected()&&isInteger(featureSelectionMaxFeatField.getText()))
			classifAction.getFeatureSelection().setMaxNumFeatures(Integer.parseInt(featureSelectionMaxFeatField.getText()));
		
	}
	
	public ClassificationAction getClassificationAction(){
		fillClassificationAction();
		if(classifAction.getName()==null||classifAction.getName().equals("")){
			classifAction.setName("Unnamed");
		}
		return classifAction;
	}
	

	public void setAccordingToCheck(boolean val,JCheckBox check,JPanel content){
		Component[] comps = content.getComponents();
		for(int i=0;i<comps.length;i++){
			if(!comps[i].equals(check)){
				comps[i].setEnabled(val);
			}
		}
	}
	
	
	public void actionPerformed(ActionEvent e){
		if(e.getSource().equals(nameCheck)){
			setAccordingToCheck(nameCheck.isSelected(),nameCheck,namePanel);
		}
		else if(e.getSource().equals(classificationNameCheck)){
			setAccordingToCheck(classificationNameCheck.isSelected(),classificationNameCheck,classificationNamePanel);
		}
		else if(e.getSource().equals(classifierTypeCheck)){
			setAccordingToCheck(classifierTypeCheck.isSelected(),classifierTypeCheck,classifierTypePanel);
		}
		else if(e.getSource().equals(classifierOptionsCheck)){
			setAccordingToCheck(classifierOptionsCheck.isSelected(),classifierOptionsCheck,classifierOptionsPanel);
		}
		else if(e.getSource().equals(commandCheck)){
			setAccordingToCheck(commandCheck.isSelected(),commandCheck,commandPanel);
		}
		else if(e.getSource().equals(classificationFeatureCheck)){
			setAccordingToCheck(classificationFeatureCheck.isSelected(),classificationFeatureCheck,classificationFeaturePanel);
		}
		else if(e.getSource().equals(positiveTrainingFileCheck)){
			setAccordingToCheck(positiveTrainingFileCheck.isSelected(),positiveTrainingFileCheck,positiveTrainingFilePanel);
		}
		else if(e.getSource().equals(negativeTrainingFileCheck)){
			setAccordingToCheck(negativeTrainingFileCheck.isSelected(),negativeTrainingFileCheck,negativeTrainingFilePanel);
		}
		else if(e.getSource().equals(positiveTrainingSSFileCheck)){
			setAccordingToCheck(positiveTrainingSSFileCheck.isSelected(),positiveTrainingSSFileCheck,positiveTrainingSSFilePanel);
		}
		else if(e.getSource().equals(negativeTrainingSSFileCheck)){
			setAccordingToCheck(negativeTrainingSSFileCheck.isSelected(),negativeTrainingSSFileCheck,negativeTrainingSSFilePanel);
		}
		else if(e.getSource().equals(outputDirCheck)){
			setAccordingToCheck(outputDirCheck.isSelected(),outputDirCheck,outputDirPanel);
		}
		else if(e.getSource().equals(functionalSiteCheck)){
			setAccordingToCheck(functionalSiteCheck.isSelected(),functionalSiteCheck,functionalSitePanel);
		}
		else if(e.getSource().equals(modelFileCheck)){
			setAccordingToCheck(modelFileCheck.isSelected(),modelFileCheck,modelFilePanel);
		}
		else if(e.getSource().equals(featuresOutputCheck)){
			setAccordingToCheck(featuresOutputCheck.isSelected(),featuresOutputCheck,featuresOutputPanel);
		}
		else if(e.getSource().equals(testFilesCheck)){
			setAccordingToCheck(testFilesCheck.isSelected(),testFilesCheck,testFilesPanel);
		}
		else if(e.getSource().equals(outputPredictionCheck)){
			setAccordingToCheck(outputPredictionCheck.isSelected(),outputPredictionCheck,outputPredictionPanel);
		}
		else if(e.getSource().equals(fileTypeCheck)){
			setAccordingToCheck(fileTypeCheck.isSelected(),fileTypeCheck,fileTypePanel);
		}
		else if(e.getSource().equals(strandCheck)){
			setAccordingToCheck(strandCheck.isSelected(),strandCheck,strandPanel);
		}
		else if(e.getSource().equals(crossvalidationCheck)){
			setAccordingToCheck(crossvalidationCheck.isSelected(),crossvalidationCheck,crossvalidationPanel);
		}
		else if(e.getSource().equals(crossvalidationComplexCheck)){
			setAccordingToCheck(crossvalidationComplexCheck.isSelected(),crossvalidationComplexCheck,crossvalidationComplexPanel);
		}
		/*else if(e.getSource().equals(maxCrossvalCheck)){
			setAccordingToCheck(maxCrossvalCheck.isSelected(),maxCrossvalCheck,maxCrossvalPanel);
		}*/
		else if(e.getSource().equals(positiveAmountCheck)){
			setAccordingToCheck(positiveAmountCheck.isSelected(),positiveAmountCheck,positiveAmountPanel);
		}
		else if(e.getSource().equals(negativeAmountCheck)){
			setAccordingToCheck(negativeAmountCheck.isSelected(),negativeAmountCheck,negativeAmountPanel);
		}
		else if(e.getSource().equals(classificationPatternCheck)){
			setAccordingToCheck(classificationPatternCheck.isSelected(),classificationPatternCheck,classificationPatternPanel);
		}
		else if(e.getSource().equals(classificationPatternLocCheck)){
			setAccordingToCheck(classificationPatternLocCheck.isSelected(),classificationPatternLocCheck,classificationPatternLocPanel);
		}
		else if(e.getSource().equals(classificationPatternOutCheck)){
			setAccordingToCheck(classificationPatternOutCheck.isSelected(),classificationPatternOutCheck,classificationPatternOutPanel);
		}
		else if(e.getSource().equals(featureSelectionTypeCheck)){
			setAccordingToCheck(featureSelectionTypeCheck.isSelected(),featureSelectionTypeCheck,featureSelectionTypePanel);
		}
		else if(e.getSource().equals(featureSelectionPurposeCheck)){
			setAccordingToCheck(featureSelectionPurposeCheck.isSelected(),featureSelectionPurposeCheck,featureSelectionPurposePanel);
		}
		else if(e.getSource().equals(featureSelectionInputFileCheck)){
			setAccordingToCheck(featureSelectionInputFileCheck.isSelected(),featureSelectionInputFileCheck,featureSelectionInputFilePanel);
		}
		else if(e.getSource().equals(featureSelectionOutputFileCheck)){
			setAccordingToCheck(featureSelectionOutputFileCheck.isSelected(),featureSelectionOutputFileCheck,featureSelectionOutputFilePanel);
		}
		else if(e.getSource().equals(featureSelectionMaxFeatCheck)){
			setAccordingToCheck(featureSelectionMaxFeatCheck.isSelected(),featureSelectionMaxFeatCheck,featureSelectionMaxFeatPanel);
		}
		
		
		//other buttons
		else if(e.getSource().equals(classificationFeatureButton)){
			JOptionPane.showMessageDialog(this,cfp,"Please provide classification features",JOptionPane.INFORMATION_MESSAGE);
			//System.out.println("TODO : show panel with classification features");
		}
		else if(e.getSource().equals(positiveTrainingFileButton)){		
			int res = fc.showOpenDialog(this);
			if(res==JFileChooser.APPROVE_OPTION && !fc.getSelectedFile().isDirectory())
				positiveTrainingFileField.setText(fc.getSelectedFile().getPath());
		}
		else if(e.getSource().equals(negativeTrainingFileButton)){
			int res = fc.showOpenDialog(this);
			if(res==JFileChooser.APPROVE_OPTION && !fc.getSelectedFile().isDirectory())
				negativeTrainingFileField.setText(fc.getSelectedFile().getPath());
		}
		else if(e.getSource().equals(positiveTrainingSSFileButton)){
			int res = fc.showOpenDialog(this);
			if(res==JFileChooser.APPROVE_OPTION && !fc.getSelectedFile().isDirectory())
				positiveTrainingSSFileField.setText(fc.getSelectedFile().getPath());
		}
		else if(e.getSource().equals(negativeTrainingSSFileButton)){
			int res = fc.showOpenDialog(this);
			if(res==JFileChooser.APPROVE_OPTION && !fc.getSelectedFile().isDirectory())
				negativeTrainingSSFileField.setText(fc.getSelectedFile().getPath());
		}
		else if(e.getSource().equals(outputDirButton)){
			JFileChooser fcDir = new JFileChooser("./");
			fcDir.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			int res = fcDir.showOpenDialog(this);
			if(res==JFileChooser.APPROVE_OPTION && fcDir.getSelectedFile().isDirectory())
				outputDirField.setText(fcDir.getSelectedFile().getPath());
		}
		else if(e.getSource().equals(modelFileButton)){
			int res = fc.showOpenDialog(this);
			if(res==JFileChooser.APPROVE_OPTION && !fc.getSelectedFile().isDirectory())
				modelFileField.setText(fc.getSelectedFile().getPath());
		}
		else if(e.getSource().equals(featuresOutputButton)){
			int res = fc.showOpenDialog(this);
			if(res==JFileChooser.APPROVE_OPTION && !fc.getSelectedFile().isDirectory())
				featuresOutputField.setText(fc.getSelectedFile().getPath());
		}
		else if(e.getSource().equals(testFilesButton)){
			int res = fc.showOpenDialog(this);
			if(res==JFileChooser.APPROVE_OPTION && !fc.getSelectedFile().isDirectory())
				testFilesField.setText(fc.getSelectedFile().getPath());
		}
		else if(e.getSource().equals(featureSelectionInputFileButton)){
			int res = fc.showOpenDialog(this);
			if(res==JFileChooser.APPROVE_OPTION && !fc.getSelectedFile().isDirectory())
				featureSelectionInputFileField.setText(fc.getSelectedFile().getPath());
		}
		
		
		else{
			System.out.println(e);
			System.out.println(e.getSource());
		}
	}


	public void keyReleased(KeyEvent source){}

	public void keyPressed(KeyEvent source){}

	public void keyTyped(KeyEvent source){
		int k=source.getKeyChar();
		if((k>47 && k<58)||k=='-'){}
		else{
			source.setKeyChar((char)KeyEvent.VK_CLEAR);
		}
	}
}
