package base.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Graphics;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JWindow;
import javax.swing.SwingUtilities;

public class SprSplashScreen extends JWindow implements Runnable{
	
	public static final long serialVersionUID = 4484868874896l; 
	public static final String SPLASH_SCREEN_IMAGE = "/fig/splash.jpg";
	
	private JProgressBar progressBar = new JProgressBar(0,100);
	private int progress = 0;
	private SplashPanel masterPanel= new SplashPanel();
	//private Icon ic = null;
	
	public SprSplashScreen(){
		//ic = new ImageIcon(this.getClass().getResource(SPLASH_SCREEN_IMAGE));
	}
	
	public void run(){
		try{
			this.setVisible(false);
			masterPanel.setLayout(new BorderLayout());
			//Icon ic = new ImageIcon(SPLASH_SCREEN_IMAGE);
			Icon ic = new ImageIcon(this.getClass().getResource(SPLASH_SCREEN_IMAGE));
			//System.out.println(this.getClass().getResource(SPLASH_SCREEN_IMAGE).toURI());
			JLabel paintLabel = new JLabel(ic);
			
			//adding progressbar
			JPanel statusPanel = new JPanel();
			statusPanel.setLayout(new FlowLayout());
			statusPanel.setBackground(Color.BLACK);
			//statusPanel.setSize(400,30);
			
			progressBar.setValue(0);
			progressBar.setStringPainted(true);
			statusPanel.add(progressBar,null);
			
			masterPanel.add(paintLabel,BorderLayout.CENTER);
			masterPanel.add(statusPanel,BorderLayout.SOUTH);
			
			this.setContentPane(masterPanel);
			this.pack();
			this.setVisible(true);
			this.setLocationRelativeTo(null);
			//centering the window
			this.repaint();
		}
		catch(Exception e){
		}
	}
	public void remove(){
		SwingUtilities.invokeLater(new Runnable() {
			public void run(){
				setVisible(false);
				dispose();
			}
		});
	}
	
	public void updateMessage(final String message){
		progress+=20;
		SwingUtilities.invokeLater(new Runnable() {
		      public void run() {
		        progressBar.setValue(progress);
		        masterPanel.message = message;
				masterPanel.repaint();
		      }
		    });
	}
	
	private class SplashPanel extends JPanel{
		
		public static final long serialVersionUID = 44848654896l; 
		
		String message = "";
		
		public SplashPanel(){
			super();
		}
		
		protected void paintComponent(Graphics g){
			super.paintComponent(g);
			//place the string in the lower right corner, 
			//but make sure it can be totally displayed.
			g.drawString(message,(int)(420-message.length()*6), 250);
		}
		
	}
	
	

}

