/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package classifier;

/**
 * Super interface which defines the use of implementation specific classifier
 * options.
 * @author Michiel Van Bel
 */
public interface ClassifierOptions {

	/**
	 * Sets classifier parameters by parsing them from an array of strings.
	 * @param params An array of strings containing the various parameters and 
	 * its values.
	 * @return Whether or not setting the parameters succeeded.
	 */
	public boolean setParameters(String[] params);
	
}
