package test;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

public class ExtractData {
	
	public static final int RANGE = 200;
	
	private List<String> positiveDonors = new ArrayList<String>();
	private List<String> negativeDonors = new ArrayList<String>();
	private List<String> positiveAcceptors = new ArrayList<String>();
	private List<String> negativeAcceptors = new ArrayList<String>();
	
	public static void main(String[] args){
		new ExtractData(args);
	}
	
	public ExtractData(String[] args){
		String coordFileName = args[0];
		List<String> data = getCoords(coordFileName);
		

		
		for(int i=0;i<data.size();i++){
			String t = data.get(i);
			String[] split = t.split(" +");
			
			String fileName = split[0];
			List<Integer> exonCoords = new ArrayList<Integer>();
			for(int j=1;j<split.length;j++){
				int coord = Integer.parseInt(split[j]);
				exonCoords.add(coord);
			}
			
			extractData(fileName,exonCoords);	
		}
		
		writeTrainingData(positiveDonors,"donors.pos");
		writeTrainingData(negativeDonors,"donors.neg");
		writeTrainingData(positiveAcceptors,"acceptors.pos");
		writeTrainingData(negativeAcceptors,"acceptors.neg");
		
	}
	
	
	public String getSequence(String fileName){
		StringBuffer buffer = new StringBuffer();
		try{
			BufferedReader reader = new BufferedReader(new FileReader(new File(fileName)));
			String s = reader.readLine();
			s = reader.readLine(); //first line is >
			while(s!=null){
				buffer.append(s);
				s = reader.readLine();
			}
			reader.close();
		}
		catch(Exception exc){
			exc.printStackTrace();
			System.exit(1);
		}
		return buffer.toString();
	}
	
	public void extractData(String fileName,List<Integer> exonCoords){
		/*String sequence = getSequence(fileName);
		if(exonCoords.size()<=2)
			return;
		
		for(int i=1;i<exonCoords.size();i++){
			int donor = exonCoords.get(i)+1;
			int acceptor = exonCoords.get(++i)-1;
			
			
			
		}*/
		
	}
	
	
	public void writeTrainingData(List<String> data,String name){
		try{
			BufferedWriter writer = new BufferedWriter(new FileWriter(new File(name)));
			for(int i=0;i<data.size();i++){
				String t = data.get(i);
				writer.write(t+"\n");
			}
			writer.close();
		}
		catch(Exception exc){
			
		}
	}

	
	public List<String> getCoords(String name){
		
		List<String> res = new ArrayList<String>();
		try{
			BufferedReader reader = new BufferedReader(new FileReader(new File(name)));
			String s = reader.readLine();
			while(s!=null){
				if(!s.equals("")&&!s.equals(" ")){
					res.add(s);
				}
				s = reader.readLine();
			}
			reader.close();
		}
		catch(Exception exc){
			exc.printStackTrace();
			System.exit(1);
		}
		return res;
	}
	
}
