package test;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

public class OutputConverter {

	public static void main(String[] args){
		new OutputConverter(args[0]);
	}
	
	
	public OutputConverter(String fileName){
		File file = new File(fileName);
		File fileOut = new File(fileName+"_GV");
		List<String> originalStrings = new ArrayList<String>();
		List<String> newStrings = new ArrayList<String>();
		try{
			BufferedReader reader = new BufferedReader(new FileReader(file));
			String s = reader.readLine();
			while(s!=null){
				originalStrings.add(s);
				s = reader.readLine();
			}
			reader.close();
			
			for(int i=0;i<originalStrings.size();i++){
				String seq = originalStrings.get(i);
				String[] split = seq.split(" ");
				StringBuffer b = new StringBuffer();
				b.append((i+1)+"\t");
				int site = Integer.parseInt(split[0]);
				if(split[1].equals("donor")){
					b.append((site)+"\t");
					b.append((site+1)+"\t");
					b.append(1+"\t");
				}
				else if(split[1].equals("donor_rev")){
					b.append(site+"\t");
					b.append((site-1)+"\t");
					b.append(-1+"\t");
				}
				else if(split[1].equals("acceptor")){
					b.append((site-2)+"\t");
					b.append((site-1)+"\t");
					b.append(1+"\t");
				}
				else if(split[1].equals("acceptor_rev")){
					b.append((site+1)+"\t");
					b.append((site)+"\t");
					b.append(-1+"\t");
				}
				//b.append(split[1]+"\t");
				b.append(getLine(split[1]));
				b.append("FunSiP"+"\t");
				b.append(split[2]);
				newStrings.add(b.toString());
			}
			
			BufferedWriter writer = new BufferedWriter(new FileWriter(fileOut));
			for(int i=0;i<newStrings.size();i++){
				writer.write(newStrings.get(i)+"\n");
			}
			writer.close();
		}
		catch(Exception exc){
			exc.printStackTrace();
			return;
		}
	}
	
	
	public static final int MIN_TABS = 4;
	private String getLine(String command){

		if(command==null)
			return null;
		int len = command.length();
		int curT = len/6;	//curT == current tabs length
		//if(len%6!=0)
		//	curT++;
		StringBuffer buf = new StringBuffer();
		buf.append("\t"+command);
		for(int i=0;i<=(MIN_TABS-curT);i++)
			buf.append("\t");
		return buf.toString();
	}
	
}
