/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package util;

import base.ClassificationAction.CLASSIFIERS;
import weka.classifiers.functions.SMO;
import weka.core.Instances;

public class SVMUtil {

	
	private Instances instances = null;
	private CLASSIFIERS svmType = CLASSIFIERS.LIBSVM;
	
	//in case svmType is WEKA, use SMO
	//else, use fileName
	private SMO smo = null;
	private String fileName = null;
	
	

	public String getFileName() {
		return fileName;
	}

	public void setFileName(String fileName) {
		this.fileName = fileName;
	}


	public CLASSIFIERS getSvmType() {
		return svmType;
	}

	public void setSvmType(CLASSIFIERS svmType) {
		this.svmType = svmType;
	}

	public SVMUtil(){
	}
	
	public SVMUtil(SMO smo, Instances instances){
		this.smo = smo;
		this.instances = instances;
	}
	
	public Instances getInstances() {
		return instances;
	}

	public void setInstances(Instances instances) {
		this.instances = instances;
	}

	public SMO getSmo() {
		return smo;
	}

	public void setSmo(SMO smo) {
		this.smo = smo;
	}
	
}
