/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package util;

public class SortingAlgorithms {

	
	public static int[] mergeSortDual(double[] data,int[] backtrack){
		if(data==null||backtrack==null||data.length!=backtrack.length)
			return null;
		if(backtrack.length==1)
			return backtrack;
		
		int[] left_backtrack = new int[backtrack.length/2];
		int[] right_backtrack = new int[backtrack.length-left_backtrack.length];
		double[] left_data = new double[data.length/2];
		double[] right_data = new double[data.length - left_data.length];
		
		System.arraycopy(backtrack,0, left_backtrack, 0, left_backtrack.length);
		System.arraycopy(backtrack,left_backtrack.length,right_backtrack,0,right_backtrack.length);
		System.arraycopy(data, 0, left_data,0,left_data.length);
		System.arraycopy(data, left_data.length, right_data, 0,right_data.length);
		
		left_backtrack = mergeSortDual(left_data,left_backtrack);
		right_backtrack = mergeSortDual(right_data,right_backtrack);
		
		mergeDual(left_data,right_data,data,left_backtrack,right_backtrack,backtrack);
		return backtrack;
	}
	
	private static void mergeDual(double[]left_data,double[]right_data,double[]data,
			int[]left_bt,int[]right_bt,int[]bt){
		
		int left_index = 0;
		int right_index = 0;
		int total_index = 0;
		
		while(left_index< left_data.length && right_index < right_data.length){
			if(left_data[left_index]>right_data[right_index]){
				data[total_index] = left_data[left_index];
				bt[total_index] = left_bt[left_index];
				left_index++;
			}
			else{
				data[total_index] = right_data[right_index];
				bt[total_index] = right_bt[right_index];
				right_index++;
			}
			total_index++;
		}
		
		int[] rest_bt;
		double[] rest_data;
		int rest_index = 0;
		if(left_index>=left_data.length){
			rest_bt = right_bt;
			rest_data = right_data;
			rest_index = right_index;
		}
		else{
			rest_bt = left_bt;
			rest_data = left_data;
			rest_index = left_index;
		}
		for(int i = rest_index;i<rest_bt.length;i++){
			data[total_index] = rest_data[i];
			bt[total_index] = rest_bt[i];
			total_index++;
		}
		
		
	}
	
	public static int[] bubbleSortDual(double[] data, int[] indices){
		if(data==null||indices==null||data.length!=indices.length)
			return null;
		if(indices.length==1)
			return indices;
		
		boolean swapped = true;
		while(swapped){
			swapped = false;
			for(int i=0;i<data.length-1;i++){
				if(data[i]>data[i+1]){
					double t = data[i];
					data[i] = data[i+1];
					data[i+1] = t;
					
					int temp = indices[i];
					indices[i] = indices[i+1];
					indices[i+1] = temp;
					swapped = true;
				}
			}
		}
		
		return indices;
	}
	
	
	public static void main(String[] args){
		
		double[] data = {0.5,0.3,0.9,0.1,0.7,0.6,0.2};
		double[] copy = new double[data.length];
		for(int i=0;i<data.length;i++)
			copy[i] = data[i];
		int[] indices = {0,1,2,3,4,5,6};
		
		//int[] res = bubbleSortDual(data,indices);
		int [] res = mergeSortDual(data,indices);
		for(int i=0;i<res.length;i++){
			//System.out.println(data[i]);
			System.out.println(copy[res[i]]);
		}
		System.out.println();
	}
	
}
