/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package util.featureSelection;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;

public class CompareFS {

	public static void main(String[] args){
		new CompareFS(args[0],args[1]);
	}
	
	public CompareFS(String fullSet,String smallSet){
		try{
			File fullFile = new File(fullSet);
			File smallFile = new File(smallSet);
			
			BufferedReader reader_full = new BufferedReader(new FileReader(fullFile));
			BufferedReader reader_small = new BufferedReader(new FileReader(smallFile));
			List<Integer> fullList = new ArrayList<Integer>();
			List<Integer> smallList = new ArrayList<Integer>();

			String sf = reader_full.readLine();
			while(sf!=null){
				int temp = Integer.parseInt(sf);
				fullList.add(temp);
				sf = reader_full.readLine();
			}
			reader_full.close();
				
			String sm = reader_small.readLine();
			sm = reader_small.readLine();
			while(sm!=null){
				if(sm.startsWith("Feature")){}
				else{
					String[] split = sm.split("\t");
					double t = Double.parseDouble(split[0]);
					int temp = Integer.parseInt(split[1]);
					if(t!=0.0)
						smallList.add(temp);
				}
				sm = reader_small.readLine();
			}
			reader_small.close();
			
			System.out.println("Full size : "+fullList.size());
			System.out.println("Small size : "+smallList.size());
			
			int smallInFull = 0;
			int smallNotInFull = 0;
			for(int i=0;i<smallList.size();i++){
				Integer temp = smallList.get(i);
				if(fullList.contains(temp))
					smallInFull++;
				else
					smallNotInFull++;
			}
			
			System.out.println("Small in full : "+smallInFull);
			System.out.println("Small not in full : "+smallNotInFull);
			
		}
		catch(Exception exc){
			exc.printStackTrace();
		}
		
		
	}
	
	
}
