/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package util.parsers.embl;

import java.util.ArrayList;
import java.util.List;

public class Embl_CDS_Data {
	public Embl_CDS_Data(){
		
	}
	
	private String name = "";
	private List<Integer> splicesites = new ArrayList<Integer>();
	private List<String> boundaries = new ArrayList<String>();
	
	private int numExons = 0;
	private boolean reverse = false;
	
	private String startCodon = "";
	private boolean correctStartCodon = false;
	
	private String stopCodon = "";
	private boolean correctStopCodon = false;
	
	private int cds_length = 0;
	private boolean correctCDSLength = false;
	
	
	
	
	
	
	public List<String> getBoundaries() {
		return boundaries;
	}
	public void setBoundaries(List<String> boundaries) {
		this.boundaries = boundaries;
	}
	public int getCds_length() {
		return cds_length;
	}
	public void setCds_length(int cds_length) {
		this.cds_length = cds_length;
	}
	public boolean isCorrectCDSLength() {
		return correctCDSLength;
	}
	public void setCorrectCDSLength(boolean correctCDSLength) {
		this.correctCDSLength = correctCDSLength;
	}
	public boolean isCorrectStartCodon() {
		return correctStartCodon;
	}
	public void setCorrectStartCodon(boolean correctStartCodon) {
		this.correctStartCodon = correctStartCodon;
	}
	public boolean isCorrectStopCodon() {
		return correctStopCodon;
	}
	public void setCorrectStopCodon(boolean correctStopCodon) {
		this.correctStopCodon = correctStopCodon;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public int getNumExons() {
		return numExons;
	}
	public void setNumExons(int numExons) {
		this.numExons = numExons;
	}
	public boolean isReverse() {
		return reverse;
	}
	public void setReverse(boolean reverse) {
		this.reverse = reverse;
	}
	public List<Integer> getSplicesites() {
		return splicesites;
	}
	public void setSplicesites(List<Integer> splicesites) {
		this.splicesites = splicesites;
	}
	public String getStartCodon() {
		return startCodon;
	}
	public void setStartCodon(String startCodon) {
		this.startCodon = startCodon;
	}
	public String getStopCodon() {
		return stopCodon;
	}
	public void setStopCodon(String stopCodon) {
		this.stopCodon = stopCodon;
	}
}
