/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package util.results;

import java.util.Map;


/**
 * This class is to be used as an instance as the result of a
 * featureExtraction from a rf or a compositional feature.
 * 
 * Because not only are the values needed (given in a Map<String,Integer>),
 * but we also need to have the maximum value (the smo does not accept
 * numeric vals, but only defined values, sigh....)
 * 
 * @author Michiel Van Bel
 */
public class ExtractionResult {

	private Map<String,Integer> result = null;
	private int max = 0;
	
	public ExtractionResult(Map<String,Integer>result,int max){
		this.result = result;
		this.max = max;
	}
	
	public ExtractionResult(){
	}

	public int getMax() {
		return max;
	}

	public void setMax(int max) {
		this.max = max;
	}

	public Map<String, Integer> getResult() {
		return result;
	}

	public void setResult(Map<String, Integer> result) {
		this.result = result;
	}
	
	
	
	
	
}
