/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package util.results;

import java.util.HashMap;
import java.util.Map;

import weka.core.Instances;

public class PotentialResultsMap {

	private String name = null;
	private Map<Integer,Instances> donorMap = null;
	private Map<Integer,Instances> acceptorMap = null;
	
	public PotentialResultsMap(){
		donorMap  = new HashMap<Integer,Instances>();
		acceptorMap = new HashMap<Integer,Instances>();
		name = new String();
	}
	
	public PotentialResultsMap(Map<Integer,Instances> donorMap,Map<Integer,Instances> acceptorMap, String name){
		this.donorMap = donorMap;
		this.acceptorMap = acceptorMap;
		this.name = name;
	}

	public Map<Integer, Instances> getAcceptorMap() {
		return acceptorMap;
	}

	public void setAcceptorMap(Map<Integer, Instances> acceptorMap) {
		this.acceptorMap = acceptorMap;
	}

	public Map<Integer, Instances> getDonorMap() {
		return donorMap;
	}

	public void setDonorMap(Map<Integer, Instances> donorMap) {
		this.donorMap = donorMap;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	
}
