package var.experimenter;

import java.awt.Dimension;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;

public class RangePanel extends JPanel{
	public static final long serialVersionUID = 44255665l;
	
	private JTabbedPane pane = null;
	
	public RangePanel(Dimension d){
		super();
		this.setMinimumSize(d);
		this.setMaximumSize(d);
		this.setPreferredSize(d);
		
		
		pane = new JTabbedPane();
		pane.setMinimumSize(d);
		pane.setMaximumSize(d);
		pane.setPreferredSize(d);
		this.add(pane);
	}
	
	
	public int getCurrentActionPanelIndex(){
		return pane.getSelectedIndex();
	}
	
	public void addActionPanel(ActionPanel panel){
		pane.insertTab(panel.getName(),null,new JScrollPane(panel),null,0);
		//pane.addTab(panel.getName(), panel);
	}
	
	public void removeActionPanel(int index){
		if(index<0)
			return;
		try{
			pane.removeTabAt(index);
		}
		catch(Exception exc){
			System.out.println(exc);
		}
	}
	
	public void clearAllActions(){
		pane.removeAll();
	}
	
	public void setActions(List<ActionPanel> list){
		if(list!=null){
			for(int i=0;i<list.size();i++){
				ActionPanel actionPanel = list.get(i);
				pane.insertTab(actionPanel.getName(),null,new JScrollPane(actionPanel),null,0);
				//pane.addTab(actionPanel.getName(), actionPanel);
			}
		}
	}
	
	public List<ActionPanel> getAllActions(){
		List<ActionPanel> list = new ArrayList<ActionPanel>();
		int count = pane.getTabCount();
		for(int i=0;i<count;i++){
			ActionPanel actionPanel = (ActionPanel)pane.getTabComponentAt(i);
			list.add(actionPanel);
		}
		
		return list;
	}
	
		
}
