package var.experimenter;

import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.JPanel;

public abstract class ScriptOptionAbstractClass extends JPanel implements ScriptOptionInterface {

	public static final long serialVersionUID = 45678l;
	
	public ScriptOptionAbstractClass(){
		super();
		this.setBorder(BorderFactory.createEtchedBorder());
	}
	
	public double extractDoubleValue(String s, double normVal){
		double retVal = normVal;
		try{
			retVal = Double.parseDouble(s);
		}
		catch(Exception exc){
			System.err.println("Error while extracting value from string ->"+s+"<-");
			System.err.println(exc);
		}
		return retVal;
	}
	
	public int extractIntValue(String s, int normVal){
		int retVal = normVal;
		try{
			retVal = Integer.parseInt(s);
		}
		catch(Exception exc){
			System.err.println("Error while extracting value from string ->"+s+"<-");
			System.err.println(exc);
		}
		return retVal;
	}
	
	public abstract List<Double> getDoubleValues();
	public abstract List<Integer> getIntValues();
	
}