package var.experimenter;

import java.awt.GridLayout;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JLabel;
import javax.swing.JTextField;

public class VariableRangeExpOption extends ScriptOptionAbstractClass{
	public final static long serialVersionUID = 12354678l;
	
	private List<Double> double_values 		= null;
	private List<Integer> integer_values	= null;
	private int minimum_exponent 		= -12;
	private int maximum_exponent 		= 4;
	private int base_exponent			= 2;
	
	private JTextField min_exp_textfield	= null;
	private JTextField max_exp_textfield	= null;
	private JTextField base_exp_textfield	= null;
	
	public VariableRangeExpOption(int min,int max,int base){
		super();
		this.setLayout(new GridLayout(1,6));
		minimum_exponent = min;
		maximum_exponent = max;
		base_exponent = base;
		
		double_values = new ArrayList<Double>();
		integer_values = new ArrayList<Integer>();
		min_exp_textfield = new JTextField(""+minimum_exponent,10);
		max_exp_textfield = new JTextField(""+maximum_exponent,10);
		base_exp_textfield = new JTextField(""+base_exponent,10);
		
		this.add(new JLabel("Minimum exponent (integer)"));
		this.add(min_exp_textfield);
		this.add(new JLabel("Maximum exponent (integer)"));
		this.add(max_exp_textfield);
		this.add(new JLabel("Base (integer)"));
		this.add(base_exp_textfield);
	}
	
	public VariableRangeExpOption(){
		super();
		this.setLayout(new GridLayout(1,6));
		double_values = new ArrayList<Double>();
		integer_values = new ArrayList<Integer>();
		min_exp_textfield = new JTextField(""+minimum_exponent,10);
		max_exp_textfield = new JTextField(""+maximum_exponent,10);
		base_exp_textfield = new JTextField(""+base_exponent,10);
		
		this.add(new JLabel("Minimum exponent"));
		this.add(min_exp_textfield);
		this.add(new JLabel("Maximum exponent"));
		this.add(max_exp_textfield);
		this.add(new JLabel("Base"));
		this.add(base_exp_textfield);
	}
	

	
	public List<Double> getDoubleValues(){
		int min_exp = extractIntValue(min_exp_textfield.getText(),minimum_exponent);
		int max_exp = extractIntValue(max_exp_textfield.getText(),maximum_exponent);
		int base_exp = extractIntValue(base_exp_textfield.getText(),base_exponent);
		double_values.clear();
		for(int i=min_exp;i<=max_exp;i++){
			double_values.add(new Double(Math.pow(base_exp,i)));
		}
		return double_values;
	}
	
	public List<Integer> getIntValues(){
		int min_exp = extractIntValue(min_exp_textfield.getText(),minimum_exponent);
		int max_exp = extractIntValue(max_exp_textfield.getText(),maximum_exponent);
		int base_exp = extractIntValue(base_exp_textfield.getText(),base_exponent);
		integer_values.clear();
		for(int i=min_exp;i<=max_exp;i++){
			int temp = (int)(Math.pow(base_exp,i));
			integer_values.add(new Integer(temp));
		}
		return integer_values;
	}
	

}