package var.experimenter;

import java.awt.GridLayout;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JLabel;
import javax.swing.JTextField;

public class VariableRangeLinearOption extends ScriptOptionAbstractClass{
	public final static long serialVersionUID = 4568l;
	
	private List<Double> double_values = null;
	private List<Integer> integer_values = null;
	
	private double minimum_value = 10;
	private double maximum_value = 100;
	private double step_value 	 = 10;
	
	private JTextField min_val_textfield = null;
	private JTextField max_val_textfield = null;
	private JTextField step_val_textfield = null;
	
	public VariableRangeLinearOption(double min,double max,double step){
		super();
		this.setLayout(new GridLayout(1,6));
		minimum_value = min;
		maximum_value = max;
		step_value = step;
		double_values = new ArrayList<Double>();
		integer_values = new ArrayList<Integer>();
		min_val_textfield = new JTextField(""+minimum_value,10);
		max_val_textfield = new JTextField(""+maximum_value,10);
		step_val_textfield = new JTextField(""+step_value,10);
		this.add(new JLabel("Minimum_value"));
		this.add(min_val_textfield);
		this.add(new JLabel("Maximum value"));
		this.add(max_val_textfield);
		this.add(new JLabel("Step"));
		this.add(step_val_textfield);
	}
	
	public VariableRangeLinearOption(){
		super();
		this.setLayout(new GridLayout(1,6));
		double_values = new ArrayList<Double>();
		integer_values = new ArrayList<Integer>();
		min_val_textfield = new JTextField(""+minimum_value,10);
		max_val_textfield = new JTextField(""+maximum_value,10);
		step_val_textfield = new JTextField(""+step_value,10);
		this.add(new JLabel("Minimum_value"));
		this.add(min_val_textfield);
		this.add(new JLabel("Maximum value"));
		this.add(max_val_textfield);
		this.add(new JLabel("Step"));
		this.add(step_val_textfield);
	}
	
	
	public List<Double> getDoubleValues(){
		double min_val = extractDoubleValue(min_val_textfield.getText(),minimum_value);
		double max_val = extractDoubleValue(max_val_textfield.getText(),maximum_value);
		double step_val = extractDoubleValue(step_val_textfield.getText(),step_value);
		double_values.clear();
		for(double i=min_val;i<=max_val;i+=step_val){
			double_values.add(i);
		}
		return double_values;
	}
	
	public List<Integer> getIntValues(){
		double min_val = extractDoubleValue(min_val_textfield.getText(),minimum_value);
		double max_val = extractDoubleValue(max_val_textfield.getText(),maximum_value);
		double step_val = extractDoubleValue(step_val_textfield.getText(),step_value);
		integer_values.clear();
		for(double i=min_val;i<=max_val;i+=step_val){
			int temp = (int)(i);
			integer_values.add(temp);
		}
		return integer_values;
	}
}