/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package util.gene;

import java.util.ArrayList;
import java.util.List;

import util.DualLocationList;

public class DNAUtil {

	
	public DNAUtil(){
		
	}
	
	public DualLocationList getPossibleLocations(String sequence,String pattern,boolean forward){
		DualLocationList res = new DualLocationList();
		List<Integer> location_in_sequence = new ArrayList<Integer>();
		List<Integer> location_in_forward = new ArrayList<Integer>();
		
		pattern = pattern.toUpperCase();
		int length = pattern.length();
		
		for(int i=0;i<sequence.length()-length;i++){
			String m_nuc = sequence.substring(i,i+length);
			if(m_nuc.equals(pattern)){
				if(forward){
					location_in_sequence.add(i);
					location_in_forward.add(i);
				}
				else{
					location_in_sequence.add(i);
					location_in_forward.add(sequence.length()-i-length);
				}
			}
		}
		
		if(!forward){
			List<Integer> l_i_f_2 = new ArrayList<Integer>();
			List<Integer> l_i_s_2 = new ArrayList<Integer>();
			for(int i=location_in_forward.size()-1;i>=0;i--){
				l_i_f_2.add(location_in_forward.get(i));
				l_i_s_2.add(location_in_sequence.get(i));
			}
			location_in_forward = l_i_f_2;
			location_in_sequence = l_i_s_2;
		}
		
		res.setLocation_in_forward(location_in_forward);
		res.setLocation_in_local(location_in_sequence);
		return res;
	}
	
	public List<Integer> getPossibleLocations2(String sequence,String pattern, boolean forward){
		List<Integer> result = new ArrayList<Integer>();
		pattern = pattern.toUpperCase();
		int length = pattern.length();
		for(int i=0;i<sequence.length()-1;i++){
			String dinuc = sequence.substring(i,i+length);
			if(dinuc.equals(pattern)){
				if(forward)
					result.add(i);
				else
					result.add((sequence.length()-i));
			}
		}
		
		if(!forward){
			List<Integer> result2 = new ArrayList<Integer>();
			for(int i=result.size()-1;i>=0;i--){
				result2.add(result.get(i));
			}
			return result2;
		}
		return result;
	}
	
	
	
	public String toOppositeStrand(String sequence){
		String temp = sequence;
		temp = temp.toUpperCase();
		StringBuffer res = new StringBuffer();
		for(int i=0;i<temp.length();i++){
			char c = temp.charAt(temp.length()-1-i);
			switch(c){
			case 'A' : res.append('T'); break;
			case 'T' : res.append('A'); break;
			case 'C' : res.append('G'); break;
			case 'G' : res.append('C'); break;
			default : res.append('N'); break;
			}
		}
		String result = new String(res);
		return result;
	}
	
}
